<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__tcpwm" kind="group">
    <compoundname>group_tcpwm</compoundname>
    <title>TCPWM        (Timer Counter PWM)</title>
    <innergroup refid="group__group__tcpwm__common">Common</innergroup>
    <innergroup refid="group__group__tcpwm__counter">Timer/Counter (TCPWM)</innergroup>
    <innergroup refid="group__group__tcpwm__pwm">PWM (TCPWM)</innergroup>
    <innergroup refid="group__group__tcpwm__quaddec">Quadrature Decoder (TCPWM)</innergroup>
    <innergroup refid="group__group__tcpwm__shiftreg">Shift Register (TCPWM)</innergroup>
    <briefdescription>
<para>The TCPWM driver is a multifunction driver that implements Timer Counter, PWM, and Quadrature Decoder functionality using the TCPWM block. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_tcpwm_counter.h, cy_tcpwm_pwm.h, cy_tcpwm_quaddec.h respectively. Include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>Each TCPWM block is a collection of counters that can all be triggered simultaneously. For each function call, the base register address of the TCPWM being used must be passed first, followed by the index of the counter you want to touch next. For some functions, you can manage multiple counters simultaneously. You provide a bit field representing each counter, rather than the single counter index).</para><para>The TCPWM supports three operating modes:<itemizedlist>
<listitem><para>Timer/Counter</para></listitem><listitem><para>PWM</para></listitem><listitem><para>Quadrature Decoder</para></listitem></itemizedlist>
</para><para><linebreak />
<bold>Timer/Counter</bold> </para><para>Use this mode whenever a specific timing interval or measurement is needed. Examples include:<itemizedlist>
<listitem><para>Creating a periodic interrupt for running other system tasks</para></listitem><listitem><para>Measuring frequency of an input signal</para></listitem><listitem><para>Measuring pulse width of an input signal</para></listitem><listitem><para>Measuring time between two external events</para></listitem><listitem><para>Counting events</para></listitem><listitem><para>Triggering other system resources after x number events</para></listitem><listitem><para>Capturing time stamps when events occur</para></listitem></itemizedlist>
</para><para>The Timer/Counter has the following features:<itemizedlist>
<listitem><para>16- or 32-bit Timer/Counter</para></listitem><listitem><para>Programmable Period Register</para></listitem><listitem><para>Programmable Compare Register. Compare value can be swapped with a buffered compare value on comparison event</para></listitem><listitem><para>Capture with buffer register</para></listitem><listitem><para>Count Up, Count Down, or Count Up and Down Counting modes</para></listitem><listitem><para>Continuous or One Shot Run modes</para></listitem><listitem><para>Interrupt and Output on Overflow, Underflow, Capture, or Compare</para></listitem><listitem><para>Start, Reload, Stop, Capture, and Count Inputs</para></listitem></itemizedlist>
</para><para><linebreak />
<bold>PWM</bold> </para><para>Use this mode when an output square wave is needed with a specific period and duty cycle, such as:<itemizedlist>
<listitem><para>Creating arbitrary square wave outputs</para></listitem><listitem><para>Driving an LED (changing the brightness)</para></listitem><listitem><para>Driving Motors (dead time assertion available)</para></listitem></itemizedlist>
</para><para>The PWM has the following features:<itemizedlist>
<listitem><para>16- or 32-bit Counter</para></listitem><listitem><para>Two Programmable Period registers that can be swapped</para></listitem><listitem><para>Two Output Compare registers that can be swapped on overflow and/or underflow</para></listitem><listitem><para>Left Aligned, Right Aligned, Center Aligned, and Asymmetric Aligned modes</para></listitem><listitem><para>Continuous or One Shot run modes</para></listitem><listitem><para>Pseudo Random mode</para></listitem><listitem><para>Two PWM outputs with Dead Time insertion, and programmable polarity</para></listitem><listitem><para>Interrupt and Output on Overflow, Underflow, or Compare</para></listitem><listitem><para>Start, Reload, Stop, Swap (Capture), and Count Inputs</para></listitem><listitem><para>Multiple Components can be synchronized together for applications such as three phase motor control</para></listitem></itemizedlist>
</para><para><linebreak />
<bold>Quadrature</bold> <bold>Decoder</bold> </para><para>A quadrature decoder is used to decode the output of a quadrature encoder. A quadrature encoder senses the position, velocity, and direction of an object (for example a rotating axle, or a spinning mouse ball). A quadrature decoder can also be used for precision measurement of speed, acceleration, and position of a motor's rotor, or with a rotary switch to determine user input. <linebreak />
 The Quadrature Decoder has the following features:<itemizedlist>
<listitem><para>16- or 32-bit Counter</para></listitem><listitem><para>Counter Resolution of x1, x2, and x4 the frequency of the phiA (Count) and phiB (Start) inputs</para></listitem><listitem><para>Index Input to determine absolute position</para></listitem><listitem><para>A positive edge on phiA increments the counter when phiB is 0 and decrements the counter when phiB is 1</para></listitem></itemizedlist>
</para><para><linebreak />
<bold>Shift</bold> <bold>Register</bold> TBD</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>For each mode, the TCPWM driver has a configuration structure, an Init function, and an Enable function.</para><para>Provide the configuration parameters in the appropriate structure (see Counter <ref kindref="compound" refid="group__group__tcpwm__data__structures__counter">Data Structures</ref>, PWM <ref kindref="compound" refid="group__group__tcpwm__data__structures__pwm">Data Structures</ref>, or QuadDec <ref kindref="compound" refid="group__group__tcpwm__data__structures__quaddec">Data Structures</ref>). Then call the appropriate Init function: <ref kindref="member" refid="group__group__tcpwm__functions__counter_1ga6068a06ddc8a07c67bb6df86e920944c">Cy_TCPWM_Counter_Init</ref>, <ref kindref="member" refid="group__group__tcpwm__functions__pwm_1ga6440d2a9dc8d85056abd62556bee7f82">Cy_TCPWM_PWM_Init</ref>, or <ref kindref="member" refid="group__group__tcpwm__functions__quaddec_1gad1949f233fc99ae5681094b5f6a499bc">Cy_TCPWM_QuadDec_Init</ref>. Provide the address of the filled structure as a parameter. To enable the counter, call the appropriate Enable function: <ref kindref="member" refid="group__group__tcpwm__functions__counter_1ga1707e2cc291fe486fbea346157c65bff">Cy_TCPWM_Counter_Enable</ref>, <ref kindref="member" refid="group__group__tcpwm__functions__pwm_1ga802ebf3a49b1056e4bc5b057deb26e49">Cy_TCPWM_PWM_Enable</ref>, or <ref kindref="member" refid="group__group__tcpwm__functions__quaddec_1ga749543ff6e63948f009d4d67f3875b53">Cy_TCPWM_QuadDec_Enable</ref>).</para><para>Many functions work with an individual counter. You can also manage multiple counters simultaneously for certain functions. These are listed in the <ref kindref="compound" refid="group__group__tcpwm__functions__common">Functions</ref> section of the TCPWM. You can enable, disable, or trigger (in various ways) multiple counters simultaneously. For these functions you provide a bit field representing each counter in the TCPWM you want to control. You can represent the bit field as an ORed mask of each counter, like ((1U &lt;&lt; cntNumX) | (1U &lt;&lt; cntNumX) | (1U &lt;&lt; cntNumX)), where X is the counter number from 0 to 31.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;ul&gt;&lt;li&gt;&lt;p&gt;If none of the input terminals (start, reload(index)) are used, the software event &lt;a href="group__group__tcpwm__functions__common.html#group__group__tcpwm__functions__common_1gabeb6819a4ac18f04f943a70c44b2bbb9"&gt;Cy_TCPWM_TriggerStart&lt;/a&gt; or &lt;a href="group__group__tcpwm__functions__common.html#group__group__tcpwm__functions__common_1ga8f4ab67e3946d84d77b54e0375eb0e48"&gt;Cy_TCPWM_TriggerReloadOrIndex&lt;/a&gt; must be called to start the counting.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;If count input terminal is not used, the &lt;a href="group__group__tcpwm__input__modes.html#group__group__tcpwm__input__modes_1ga6f8ffc8c36941d7d44290147032fd33b"&gt;CY_TCPWM_INPUT_LEVEL&lt;/a&gt; macro should be set for the countInputMode parameter and the &lt;a href="group__group__tcpwm__input__selection.html#group__group__tcpwm__input__selection_1ga7369f85b221bf7c70e1a580daa6a6bef"&gt;CY_TCPWM_INPUT_1&lt;/a&gt; macro should be set for the countInput parameter in the configuration structure of the appropriate mode(Counter &lt;a href="group__group__tcpwm__data__structures__counter.html#"&gt;Data Structures&lt;/a&gt;, PWM &lt;a href="group__group__tcpwm__data__structures__pwm.html#"&gt;Data Structures&lt;/a&gt;, or QuadDec &lt;a href="group__group__tcpwm__data__structures__quaddec.html#"&gt;Data Structures&lt;/a&gt;).&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><bold>Assign and Configure Pins</bold></para>
<para>The dedicated TCPWM pins can be used. The HSIOM register must be configured to connect the block to the pins. Use the <ref kindref="compound" refid="group__group__gpio">GPIO (General Purpose Input Output)</ref> driver API to do that.</para><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />P0[0]<sp />is<sp />the<sp />dedicated<sp />pin<sp />for<sp />the<sp />first<sp />counter<sp />of<sp />the<sp />TCPWM0<sp />block:<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__gpio__functions__init_1gaf57c501727276013d3e8974a9fb7d0a7">Cy_GPIO_Pin_FastInit</ref>(GPIO_PRT0,<sp />0UL,<sp /><ref kindref="member" refid="group__group__gpio__drive_modes_1gacebd8bea6222d742bdfbfd86dabab940">CY_GPIO_DM_STRONG_IN_OFF</ref>,<sp />0UL,<sp />P0_0_TCPWM0_LINE0);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> </para>

<para><bold>Assign Clock Divider</bold></para>
<para>The clock source must be connected to proper working. Any of the peripheral clock dividers could be used. Use the <ref kindref="compound" refid="group__group__sysclk">SysClk (System Clock)</ref> driver API to do that.</para><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />Assign<sp />the<sp />first<sp />8-bit<sp />peripheral<sp />clock<sp />divider<sp />with</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />divide<sp />ratio<sp />=<sp />100<sp />to<sp />the<sp />first<sp />counter<sp />of<sp />the<sp />TCPWM0<sp />block:</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gacb66324e3191006f6d1cee8b29238fb2">Cy_SysClk_PeriphAssignDivider</ref>(PCLK_TCPWM0_CLOCKS0,<sp /><ref kindref="member" refid="group__group__sysclk__clk__peripheral__enums_1gga06138349be16d91fd5d00ded2f4592b8ad2299deae6e36a070de5a60368b319ad">CY_SYSCLK_DIV_8_BIT</ref>,<sp />0UL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1gac67931844e6ec06b5ff88f4f3119e127">Cy_SysClk_PeriphSetDivider</ref>(<ref kindref="member" refid="group__group__sysclk__clk__peripheral__enums_1gga06138349be16d91fd5d00ded2f4592b8ad2299deae6e36a070de5a60368b319ad">CY_SYSCLK_DIV_8_BIT</ref>,<sp />0UL,<sp />99UL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__sysclk__clk__peripheral__funcs_1ga8c626f11b583d8296516bbcf4a22f98e">Cy_SysClk_PeriphEnableDivider</ref>(<ref kindref="member" refid="group__group__sysclk__clk__peripheral__enums_1gga06138349be16d91fd5d00ded2f4592b8ad2299deae6e36a070de5a60368b319ad">CY_SYSCLK_DIV_8_BIT</ref>,<sp />0UL);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> </para>


<para><heading level="1">More Information</heading></para>
<para>For more information on the TCPWM peripheral, refer to the technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast should not be performed between a pointer to object type and a different pointer to object type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;This piece of code is written for TCPWM_V2_Type only and it will be never executed for TCPWM_V1_Type (which is a default build option for &lt;a href="struct_t_c_p_w_m___type.html#"&gt;TCPWM_Type&lt;/a&gt;).  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;14.2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;All non-null statements shall either: a) have at least one side-effect however executed, or b) cause control flow to change. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The unused function parameters are cast to void. This statement has no side-effect and is used to suppress a compiler warning.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10.2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added header guards CY_IP_MXTCPWM. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;To enable the PDL compilation with wounded out IP blocks.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added a deviation to the MISRA Compliance section. Added function-level code snippets. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>